/*
  "EEPROMdataStorage"
  Library supporting storage of different data formats in Arduino EEPROM
  V1.1 / Copyright (C) 2017, T.Rode (DL1DUZ)

  Permission is granted to use, copy, modify, and distribute this software
  and documentation for non-commercial purposes.
*/

#ifndef EEPROMdataStorage_h_
#define EEPROMdataStorage_h_

#if (ARDUINO >= 100)
#include <Arduino.h> 
#else
#include <WProgram.h> 
#endif

#if (ARDUINO >= 100)
#include <Arduino.h> 
#else
#include <WProgram.h> 
#endif

#include <stdint.h>
// Arduino's built-in EEPROM library
#include <EEPROM.h>

//################################################################################################################
//definitions
//################################################################################################################

class EEPROMdataStorageClass {

public:

  uint16_t dataFromEEPROM(uint16_t address, void *target, uint8_t size, uint16_t elements);
  uint16_t dataToEEPROM(uint16_t address, const void *source, uint8_t size, uint16_t elements);

private:

  uint16_t dataTransfer(uint16_t *address, uint8_t *ram, uint8_t *size, uint16_t *elements, uint8_t write);
};

extern EEPROMdataStorageClass EEPROMDS;

#endif // EEPROMdataStorage_h_
