/*
  "Polynomial"
  Library supporting two-dimensional linear fits of an injective non-linear function (e.g. sensor data, polynomial)
  with 16 bit resolution. Support point data is being stored in EEPROM.
  V0.10 / Copyright (C) 2020, T.Rode (DL1DUZ)

  Permission is granted to use, copy, modify, and distribute this software
  and documentation for non-commercial purposes.
*/

#ifndef Polynomial_h_
#define Polynomial_h_

#include <stdint.h>
// Arduino's built-in EEPROM library
#include <EEPROM.h>
// Library supporting storage of different data formats in Arduino EEPROM
#include <EEPROMdataStorage.h>

//################################################################################################################
//definitions
//################################################################################################################

class PolynomialClass {

public:

  uint16_t writeSupportPoints(int16_t *x, int16_t *y, uint16_t size, uint16_t address);
  int16_t getValue(int16_t x, uint16_t size, uint16_t address);

};

extern PolynomialClass Poly;

#endif // Polynomial_h_
